## Testing Framework

- **Preferred Framework**: mocha
- **Version**: 11.0.1

## Naming Conventions

- **Test Files**: Name test files using the pattern `*.test.js`
- **Test Cases**: Use descriptive names that clearly indicate the purpose of the test, e.g., `shouldReturnUserWhenValidIdProvided`.

## Test Structure

1. **Setup**: Initialize necessary objects and mock dependencies.
2. **Execution**: Invoke the function or method being tested.
3. **Assertion**: Verify that the outcome matches the expected result. 
4. **FilePosition**: Put `*.test.js` in the same file path with source

## Mocking and Stubbing

- **External Dependencies**: Mock external APIs, databases, and other services to ensure tests are reliable and do not depend on external systems.
- **Data Mocks**: Use realistic mock data that closely resembles actual data used in the application.

## Best Practices

- **Isolation**: Each test should be independent and not rely on the outcome of other tests.
- **Readability**: Write clear and concise test cases that are easy to understand.
- **Performance**: Ensure tests run quickly to facilitate rapid development and feedback.
- **Maintainability**: Write tests that are easy to maintain and update as the codebase evolves.